;----------------------------------------------------------------
;	Serial.asm prog to Conect TO 504		                ;
;	masm32 version						          ;
;	Roger Stone 7-4-2006,  19-9-2008				    ;
;----------------------------------------------------------------

include \masm32\include\masm32rt.inc
include \masm32\include\winio.inc
includelib \masm32\lib\winio.lib
.486                                      ; create 32 bit code

WinMain		proto :DWORD,:DWORD,:DWORD,:DWORD
;----------------------------------------------------------------
 .data?
hInstance	HINSTANCE ?
CommandLine	LPSTR ?
hMenu		HANDLE ?
ExitCode	DWORD ?
hwnd		HANDLE ?
hEdit		dd ?
ThreadID	DWORD ?
dcb DCB<>
cmtout COMMTIMEOUTS<>
BuffRxD db 20h dup (?)
BuffTxD db 20h dup (?)
hFilePort HANDLE ?
FileWSize dd ?
FileRSize dd ?
;----------------------------------------------------------------
.const
IDM_CREATE_THREAD	equ 1
IDM_EXIT		equ 2
WM_SERIAL_DATA		equ WM_USER+200h
;BAUD_RATE equ CBR_115200
 BAUD_RATE equ CBR_19200


EditID equ 1
;----------------------------------------------------------------
.data
	ClassName	db "WindClass",0
	EditClass	db "Edit",0
	AppName	db "Win32 ASM MultiThreading Example",0
	MenuName	db "FirstMenu",0
	BuffPortName  db "COM1",0
	message1	db " Longer String 1 ",0Dh,0Ah,0
;	message1	db " Longer String 1A ",0Dh,0Ah," More String 1B "0
	message2	db " String 2 ",0Dh,0Ah,0
	message3	db " String 3 ",0Dh,0Ah            
	message4	db " String 4 ",0Dh,0Ah
	message5	db " Bad Settings ",0Dh,0Ah
	CHOUT		DD 020h
      RCKEEP      DD 0 
char WPARAM 20h                         ; the character the program receives from keyboard 
pointer DD    0                         ; pointer to move char about

;----------------------------------------------------------------
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax

    	call InitializeWinIo		      ; initialise WinIo 
 	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
 
				           
	call ShutdownWinIo		      ; Must clean up WinIo 
	invoke FlushFileBuffers, hFilePort  ; close serial
	invoke CloseHandle, hFilePort

	invoke ExitProcess,eax

;----------------------------------------------------------------
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW+ ES_MULTILINE+ ES_AUTOHSCROLL+ ES_AUTOVSCROLL,300,\
           300,500,200,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	invoke GetMenu,hwnd
	mov  hMenu,eax  


	call OpenPort
      test eax,eax                          ; Did it open?
      jnz w1
      print "Serial failed", 0Dh,0Ah
      jmp w2
      
w1:		;initialise buffer pointer
	sub eax,eax
	mov [FileWSize],eax

		; start serial thread
	mov  eax,OFFSET SerialThread
	invoke CreateThread, NULL, NULL, eax, NULL,\
	     NORMAL_PRIORITY_CLASS, ADDR ThreadID
	invoke CloseHandle,eax

w2:
	.WHILE TRUE
                invoke GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
;----------------------------------------------------------------
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT

	.IF uMsg==WM_DESTROY

		invoke PostQuitMessage,NULL

	.ELSEIF uMsg==WM_CREATE
		INVOKE CreateWindowEx,NULL,ADDR EditClass,NULL,\
                   WS_VISIBLE or WS_CHILD or ES_LEFT or ES_MULTILINE or ES_AUTOVSCROLL ,\
                 0,\	; or ES_AUTOHSCROLL
                   0,0,0,hWnd,EditID,\
                   hInstance,NULL
		mov hEdit,eax
;	invoke ShowWindow, hEdit,SW_SHOWNORMAL
;	invoke UpdateWindow, hEdit

;		invoke SetFocus,hEdit

;	.ELSEIF uMsg==WM_SIZE
;		mov eax,lParam
;		mov edx,eax
;		shr edx,16
;	sub edx,080h
;		and eax,0ffffh
;		invoke MoveWindow,hEdit,0,0,eax,edx,TRUE


	.ELSEIF uMsg==WM_CHAR
		mov eax, wParam
            mov [char],eax
		mov ebx,offset BuffTxD
		add ebx,[FileWSize]		; point to next 
		mov [ebx], al
		add [FileWSize],1		; inc char count/point to next space
		call emit			; echo char
		cmp eax,0Dh
		jnz c6				; don't send until CR
		lea eax, FileWSize
		invoke WriteFile, hFilePort, addr BuffTxD, FileWSize, eax, NULL
		sub eax,eax
		mov [FileWSize],eax		; reset char count
            invoke InvalidateRect, hWnd,NULL,TRUE 

c6:

	.ELSEIF uMsg==WM_PAINT
		invoke BeginPaint,hWnd, ADDR ps
		mov    hdc,eax
		invoke GetClientRect,hWnd, ADDR rect
		invoke DrawText, hdc,ADDR message1,-1, ADDR rect, DT_EDITCONTROL+DT_WORDBREAK      ;Must have 0 terminator
		invoke DrawText, hdc,ADDR message2,-1, ADDR rect, DT_EDITCONTROL+DT_WORDBREAK      
;		invoke DrawText, hdc,ADDR BuffRxD,-1, ADDR rect, DT_EDITCONTROL+DT_WORDBREAK      ;Must have 0 terminator


            mov eax,[pointer]           ; Move the position of the character
            inc eax
            mov [pointer],eax    
            imul eax,8 

            invoke TextOut,hdc,eax,48,offset char,1 

            invoke SetBkColor,hdc,0ffFFh 
            invoke TextOut,hdc,300,0,ADDR message3,SIZEOF message3  ;SIZEOF sees CRLF so prints ||, why ||

            invoke TextOut,hdc,100,64,ADDR BuffRxD,FileRSize

		invoke EndPaint,hWnd, ADDR ps

	.ELSEIF uMsg==WM_SERIAL_DATA
		mov ecx, FileRSize
		cmp ecx,0
		jz s3
		lea esi, BuffRxD
s1:		movzx eax,byte ptr[esi]
	      cmp al,0Dh
	      jnz s2
	      push eax 
	      mov eax,0Ah
	      call emit
	      pop eax
s2:		call emit
		inc esi
		loop s1
s3:	

  ;          invoke InvalidateRect, hWnd,NULL,TRUE 

; print "Serial Message Rec    "
; print offset BuffRxD, 0Dh,0Ah

	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp

;----------------------------------------------------------------
SerialThread PROC USES ecx Param:DWORD

 print "Start Serial Thread",0Dh,0Ah

T1:
	  mov FileRSize, 8
        invoke ReadFile, hFilePort,addr BuffRxD,FileRSize,addr FileRSize,NULL
	  or eax, eax				
	  jz T2					                  ; jump on fail
	  mov eax, FileRSize
        or eax,eax
	  jz T1				                    	; jump on empty		
        invoke SendMessage,hwnd,WM_SERIAL_DATA,NULL,NULL	; send flag data recieved,place to send it, message, , ,
	  jmp T1
T2:
 ; print " Receive serial Error ",0Dh,0Ah

        jmp T1
SerialThread ENDP
; -------------------------------------------------------------------------
OpenPort: 
 print "Setting COM1",0Dh,0Ah

	invoke CreateFile, chr$("COM1"),\		; lpFileName - pointer to name of the file
	  GENERIC_READ or GENERIC_WRITE,\	      ; dwDesiredAccess - access (read-write) mode
	  NULL,\			        	      ; dwShareMode - share mode
	  NULL,\				            ; lpSecurityAttributes - pointer to security attributes
	  OPEN_EXISTING,\			            ; dwCreationDistribution - how to create
	  0,\ ;FILE_ATTRIBUTE_NORMAL,\		; dwFlagsAndAttributes - file attributes
	  NULL					      ; hTemplateFile - handle to file with attributes to copy
	mov hFilePort, eax

	cmp eax, INVALID_HANDLE_VALUE
	jz BadSettings					            ; jump if file not created

		invoke GetCommState, hFilePort, ADDR dcb

	and eax,eax
	jz BadSettings				      ; jump if bad state

		mov dcb.DCBlength, sizeof dcb
		mov dcb.BaudRate, BAUD_RATE         ;19200
		mov  dcb.fbits, BITRECORD<\
		  TRUE,\	         	  ; fBinary:1
		  FALSE,\		        ; fParity:1
		  FALSE,\			  ; fOutxCtsFlow:1
		  FALSE,\			  ; fOutxDsrFlow:1
		  DTR_CONTROL_DISABLE,\	  ; fDtrControl:2
		  FALSE,\			  ; fDsrSensitivity:1
		  TRUE,\			  ; fTXContinueOnXoff:1
		  FALSE,\			  ; fOutX:1
		  FALSE,\			  ; fInX:1
		  FALSE,\			  ; fErrorChar:1
		  FALSE,\			  ; fNull:1
		  RTS_CONTROL_DISABLE,\	  ; fRtsControl:2
		  FALSE,\			  ; fAbortOnError:1
		  NULL>			  ; fDummy2:17
		mov dcb.ByteSize, 8
		mov dcb.Parity, NOPARITY	     
		mov dcb.StopBits, ONESTOPBIT	      ; 0,1,2 for 1, 1.5, 2
		mov dcb.ErrorChar, 0FFh
		mov dcb.EvtChar, 0
		invoke SetCommState, hFilePort, ADDR dcb
	      and eax, eax
	      jz BadSettings

 print "COM1 is set",0Dh,0Ah
 
		invoke GetCommTimeouts, hFilePort, ADDR cmtout
   .IF eax == 0
      print "GetCommTimeouts failed",0Dh,0Ah
   .ENDIF
		mov cmtout.ReadIntervalTimeout, 3	      	; Timeout between received bytes [ms]
		mov cmtout.ReadTotalTimeoutMultiplier, 3	      ; Timeout part multipled by number of bytes to receive [ms]
		mov cmtout.ReadTotalTimeoutConstant, 5		; Constant part of receive timeout [ms]
		mov cmtout.WriteTotalTimeoutMultiplier, 10	; Timeout part multipled by number of bytes to transmit [ms]
		mov cmtout.WriteTotalTimeoutConstant, 100	      ; Constant part of transmit timeout [ms]

		invoke SetCommTimeouts, hFilePort, ADDR cmtout
   .IF eax == 0
      print "GetCommTimeouts failed",0Dh,0Ah
   .ENDIF
		invoke SetupComm, hFilePort, 4096, 4096 	; COMM_INBUFSIZE,COMM_OUTBUFSIZE
   .IF eax == 0
      print "SetUpComm failed",0Dh,0Ah
   .ENDIF
		invoke PurgeComm, hFilePort, PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR 
   .IF eax == 0
      print "PurgeComm failed",0Dh,0Ah
   .ENDIF
	

	mov eax, hFilePort
	ret
; ------------------
BadSettings:
	
 print "COM1 is not set",0Dh,0Ah


	call ShutdownWinIo		      ; Must clean up WinIo 
	invoke FlushFileBuffers, hFilePort  ; close serial
	invoke CloseHandle, hFilePort
	mov hFilePort, eax 	
	xor eax, eax                        ; Flag failure
	ret
;----------------------------------------------------------------
emit:		push ecx
		push eax
		mov [CHOUT],eax
		push -11
		call GetStdHandle
            push 0				; not overlappedHi All
		push offset RCKEEP		; buffer to put return count
		push 1				; no of bytes
		push offset CHOUT		; char
		push eax			; handle to console
		call WriteFile
call outchth
		pop eax	
		pop ecx	
		ret
;----------------------------------------------------------------
outchth:
		invoke [SendMessage], [hEdit], EM_REPLACESEL, 0, offset CHOUT
		ret
;----------------------------------------------------------------
end start

